import numpy as np
import scipy.special as sp
import matplotlib.pyplot as plt
from pylab import *
from legendre import *
def legKernelMatrix( n_leg, lambdas):
#
# K = legKernelMatrix( n_leg, lambdas)
#
# Construct kernel matrix for space spanned by all Legendre polynomials up 
# to degree n_leg
#
# @retrun  K        kernel matrix
# @param   n_leg    maximum Legendre degree
# @param   lambdas  sampling points


  # generate values
  K = zeros( (len(lambdas), n_leg+1));
  
  # construct kernel matrix: 
  # - each column is fixed basis function
  # - each row is one fixed lambda
  for n in range (0 , n_leg+1):
    coeffs = Legendre.eval( n, lambdas);
    K[:,n] = coeffs;  

  return K  

