# Plot basis expansion for Legendre polynomials

execfile('legInit.py')

# random signals (coefficients for n_leg = 4)
# coeffs = 0.5 * randn( 1, n_leg+1);
# fix coefficients for reproducibility
coeffs = [0.7097, 0.1458, 0.0989, 0.7938, -0.4022]
sig_vals = Legendre.signal(coeffs, xvals);

# generate values
vals_leg_polys = zeros((n_leg + 1, len(xvals)));

for n in range(0, n_leg+1):
  cdat = Legendre.eval( n, xvals);
  vals_leg_polys[n,:] = cdat;

## Visualization

execfile('legPreVisualization.py');

# plot Legendre basis functions
for n in range(0 , n_leg+1):
  col = cols[n];
  col =[((i==0.0) * 0.8) + i for i in col]
  plot( xvals, vals_leg_polys[n,:], '-', color=col);


# plot signal
plot( xvals, sig_vals, '-r');

# set parameters for saving
execfile('legPostVisualization.py')
# save image
plt.savefig( 'figures/legPlotBasisExpansion.eps')
plt.savefig( 'figures/legPlotBasisExpansion.pdf')


