# Plot basis expansion for Legendre polynomials

execfile('legInit.py')

# generate values
vals_leg_polys = zeros((n_leg + 1, len(xvals)));

for n in range(0, n_leg+1):
  cdat = Legendre.eval( n, xvals);
  vals_leg_polys[n,:] = cdat;

#

# random signals (coefficients for n_leg = 4)
# fix coefficients for reproducibility
coeffs_1 = [-0.0065, 0.0092, -0.0238, 0.5752, -0.0681];
coeffs_2 = [0.0228, -0.0424, -0.0167, -1.1176, 0.0520];

# generate signal samples
sig_vals_1 = Legendre.signal(coeffs_1, xvals);
sig_vals_2 = Legendre.signal(coeffs_2, xvals);

## Visualization

# visualize
execfile('legPreVisualization.py');

# plot Legendre basis functions
for n in range (0, n_leg+1):  
  col = cols[n];
  col =[((i==0.0) * 0.8) + i for i in col]
  plot( xvals, vals_leg_polys[n,:], '-', color=col); 

# plot signal
plot( xvals, sig_vals_1, '-r');
plot( xvals, sig_vals_2, '-b');

# set parameters for saving
execfile('legPostVisualization.py');
# save image
plt.savefig( 'figures/legPlotInnerProduct_a.eps')
plt.savefig( 'figures/legPlotInnerProduct_a.pdf')


print('dot(coeffs_1,coeffs_2) = '+ str(np.dot(coeffs_1,coeffs_2)));

# 
  
# random signals (coefficients for n_leg = 4)
# fix coefficients for reproducibility
coeffs_1 = [0.0630, 0.0330, -0.0034, 0.8261, -0.0109];
coeffs_2 = [0.0763, 0.0233, -0.0105, 0.0313, -1.0298];

# generate signal samples
sig_vals_1 = Legendre.signal(coeffs_1, xvals);
sig_vals_2 = Legendre.signal(coeffs_2, xvals);

# plot 
plt.figure()
execfile('legPreVisualization.py');

# plot Legendre basis functions
for n in range (0 , n_leg+1):  
  col = cols[n];
  col =[((i==0.0) * 0.8) + i for i in col]
  plot( xvals, vals_leg_polys[n,:], '-', color=col);      


# plot signal
plot( xvals, sig_vals_1, '-r');
plot( xvals, sig_vals_2, '-b');

# set parameters for saving
execfile('legPostVisualization.py');
# save image
plt.savefig( 'figures/legPlotInnerProduct_b.eps')
plt.savefig( 'figures/legPlotInnerProduct_b.pdf')

print('dot(coeffs_1,coeffs_2) = '+ str(np.dot(coeffs_1,coeffs_2)));


