# Plot random signals in the space

execfile('legInit.py')

n_rands_ip = 3
# scaling to make L_\infty norm appropriate for plotting
coeff_scaling = 0.25

# generate values
xvals = arange(-1.0, 1.0, 0.001)
vals_rands_ip = np.zeros((n_rands_ip, np.size(xvals)))

#coeffs_rands_ip = coeff_scaling * randn( n_rands_ip, n_leg+1) 
# 
# # make one coefficient dominant
#for i in range(0, n_rands_ip):
    #coeffs_rands_ip[i , n_leg-(i-1)] = coeffs_rands_ip[i , n_leg - (i-1)] * 2.5

# fix randomly generated coefficients for reproducibility
coeffs_rands_ip = np.array([ [-0.0137,    0.0624,   -0.1602,    0.0498,   -0.3708], 
                    [-0.2797,   -0.2483,    0.4522,   -0.9506,    0.1003],
                    [-0.1566,    0.2437,   -0.6749,   -0.1809,    0.2355]])

for n in range(0,n_rands_ip):
  vals_rands_ip[n,:] = Legendre.signal(coeffs_rands_ip[n,:], xvals)

# generate values of basis functions
vals_leg_polys = np.zeros( (n_leg + 1, np.size(xvals)))

for n in range(0, n_leg+1):
  cdat = Legendre.eval( n, xvals)
  vals_leg_polys[n,:] = cdat

# visualize
execfile('legPreVisualization.py')

# plot Legendre basis functions
for n in range(0, n_leg+1):
  plot( xvals, vals_leg_polys[n,:],':', color=cols[n])

cols_ip = ['r', 'g', 'b']
for n in range(0,n_rands_ip):
  plot( xvals, vals_rands_ip[n,:], '-'+cols_ip[n])


execfile('legPostVisualization.py')

plt.savefig( 'figures/legPlotInnerProducts.eps')
plt.savefig( 'figures/legPlotInnerProducts.pdf')

