# Plot reproducing kernels at three points in [-1,1]

execfile("legInit.py");

delta = 2.0 / (n_leg+1);
lambdas = arange(-1.0, 1.0,delta);
lambdas = lambdas + delta / 2.0;

# generate values
K = zeros((n_leg + 1, n_leg+1));

# construct kernel matrix: 
# - each column is fixed basis function
# - each row is one fixed lambda
for n in range (0, n_leg+1):
  coeffs = Legendre.eval(n,lambdas);
  K[:,n] = coeffs;  

# values of kernel and dual kernel functions
vals_k = zeros( (n_leg+1, len(xvals)));

for i in range(0, len(lambdas)):
  vals_k[i,:] = Legendre.signal(K[i,:], xvals);

##

# random signal
coeffs = np.array([0.7097, 0.1458, 0.0989,  0.7938,  -0.4022]);

sig = Legendre.signal(coeffs, xvals); 

f_lambdas = K * np.transpose(matrix(coeffs));

## visualize
plt.figure()
execfile("legPreVisualization.py");


## plot basis functions
for i in range(0, len(lambdas)):  
  col = cols[i];
  col= [(col[j] == 0.0) *0.8 + col[j] for j in range(0,len(col))]
  
  plot( lambdas[i], 0.0, 'x', markersize=10, color=col);
  plot( xvals, vals_k[i,:], '-', color=col);



plot( xvals, sig, '-r');
for i in range(0, len(lambdas)):
  plot( lambdas[i], f_lambdas[i], 'xr', markersize=15);


execfile("legPostVisualization.py");
ylim( [-3.0, 3.0])

plt.savefig( 'figures/legPlotKernelMatrix.eps')
plt.savefig( 'figures/legPlotKernelMatrix.pdf')

