from legKernelMatrix import *
# Show the effect of oversampling on the quality measure

execfile("legInit.py");

# for averaging 
num_rands = 100;

mus = [];
for m in range (n_leg+1 , 20 * (n_leg+1)+1):
  
  cur = 0.0;
  for a in range(1 , num_rands+1):
  
    # construct sampling points
    lambdas = rand(m);
    lambdas = sort( (2.0 * lambdas) - 1.0);
    
    # construct corresponding kernel matrix
    K = legKernelMatrix( n_leg, lambdas);
  
    cur = cur + cond(K);   
  
    
  mus = np.append(mus, cur / num_rands);  


print(mus[len(mus)-1])
### Visualization

execfile("legPreVisualization.py");

plot( range(n_leg+1 , n_leg + len(mus)+1), mus, '-r');
plot( range(n_leg+1, n_leg + len(mus)+1), ones(len(mus)), color=[0.8, 0.8, 0.8]);

execfile("legPostVisualization.py");


xlim( [n_leg+1 , n_leg + len(mus)+1]);
ylim( [1e0, max(mus)]);
yscale('log')
yticks([1e0, 1e1, 1e2, 1e3])

plt.savefig( 'figures/legPlotMuOversampling.eps')
plt.savefig( 'figures/legPlotMuOversampling.pdf')
