# Plot reproducing kernels at three points in [-1,1]

execfile("legInit.py")

# locations of reproducing point
#p = haltonset( 1, 'Skip', 1e3, 'Leap', 1e2);
#p = scramble( p, 'RR2');
# lambdas = net( p, n_leg+1);

# lambdas = halton( 5, 1);
# lambdas = sort( (2.0 * lambdas) - 1.0);

delta = 2.0 / (n_leg+1);
lambdas = arange(-1.0 ,1.0,delta);
lambdas = lambdas + delta / 2.0;

# generate values
K = zeros((n_leg + 1, n_leg+1));

# construct kernel matrix: 
# - each column is fixed basis function
# - each row is one fixed lambda
for n in range (0, n_leg+1):
  coeffs = Legendre.eval(n,lambdas);
  K[:,n] = coeffs;  

# sampling matrix
# - i-th column is formed by basis function coefficients for i-th dual
#   basis function 
S = inv(K);

# values of kernel and dual kernel functions
vals_k = zeros( (n_leg+1, len(xvals)));
vals_kd = zeros( (n_leg+1, len(xvals)));

for i in range(0, len(lambdas)):
  vals_k[i,:] = Legendre.signal(K[i,:], xvals);
  vals_kd[i,:] = Legendre.signal( S[:,i], xvals);


## visualize


execfile("legPreVisualization.py");

# plot basis functions
for i in range(0, len(lambdas)):
  plot( xvals, vals_k[i,:], '-', color=cols[i]);


# plot corresponding reproducing points
for i in range(0, len(lambdas)):
  plot( lambdas[i], 0.0, 'x', markersize=15, color=cols[i]);

execfile("legPostVisualizationTight.py");
ylim( [-3.0, 3.0]);

plt.savefig( 'figures/legPlotRKBasisTight_a.eps')
plt.savefig( 'figures/legPlotRKBasisTight_a.pdf')


###
plt.figure();
execfile("legPreVisualization.py");

# plot basis functions
for i in range(0 , len(lambdas)):
  plot( xvals, vals_kd[i,:], '-', color=cols[i]);

## The following is an example of reconstruction for sin function
#cs=[sin(-0.8),sin(-0.4),sin(0.0),sin(0.4),sin(0.8)]
#vals=zeros(len(xvals));
#for i in range(0 , len(lambdas)):
  #vals = vals + cs[i]*vals_kd[i,:];
#plot( xvals, vals);


execfile("legPostVisualizationTight.py");
ylim( [-3.0, 3.0]);
plt.savefig( 'figures/legPlotRKBasisTight_b.eps')
plt.savefig( 'figures/legPlotRKBasisTight_b.pdf')




