# Plot reproducing kernels at three points in [-1,1]

execfile("legInit.py");

# locations of reproducing point
#p = haltonset( 1, 'Skip', 1e3, 'Leap', 1e2);
#p = scramble( p, 'RR2');
# lambdas = net( p, n_leg+1);

#lambdas = halton( 5, 1);
#lambdas = sort( (0.35 * lambdas) - 0.2);

# fixed lambdas for reproducibility
lambdas = [ -0.1562, -0.1125, -0.0250, 0.0187, 0.0625];

# generate values
K = zeros((n_leg + 1, n_leg+1));

# construct kernel matrix: 
# - each column is fixed basis function
# - each row is one fixed lambda
for n in range (0, n_leg+1):
  coeffs = Legendre.eval(n,lambdas);
  K[:,n] = coeffs;  

# sampling matrix
# - i-th column is formed by basis function coefficients for i-th dual
#   basis function 
S = inv(K);

# values of kernel and dual kernel functions
vals_k = zeros( (n_leg+1, len(xvals)));
vals_kd = zeros( (n_leg+1, len(xvals)));

for i in range(0, len(lambdas)):
  vals_k[i,:] = Legendre.signal(K[i,:], xvals);
  vals_kd[i,:] = Legendre.signal( S[:,i], xvals);

## visualize

execfile("legPreVisualization.py");

# plot basis functions
for i in range(0, len(lambdas)):
  plot( xvals, vals_k[i,:], '-', color=cols[i]);


# plot corresponding reproducing points
for i in range(0, len(lambdas)):
  plot( lambdas[i], 0.0, 'x', markersize=15, color=cols[i]);

execfile("legPostVisualizationTight.py");
ylim( [-3.0, 3.0])

plt.savefig( 'figures/legPlotRKBasisBad_a.eps')
plt.savefig( 'figures/legPlotRKBasisBad_a.pdf')
##

plt.figure();
execfile("legPreVisualization.py");

plot( [0.0, 0.0], [-30000.0, 30000.0], color=[0.8, 0.8, 0.8]);

# plot basis functions
for i in range(0 , len(lambdas)):
  plot( xvals, abs(vals_kd[i,:]), '-', color=cols[i]);

execfile("legPostVisualizationTight.py");
ylim( [-30000.0, 30000.0]);
# set( gca, 'YScale', 'log');

plt.savefig( 'figures/legPlotRKBasisBad_b.eps')
plt.savefig( 'figures/legPlotRKBasisBad_b.pdf')

# 
plt.figure();
execfile("legPreVisualization.py");
plot( [0.0, 0.0], [-30.0, 30.0], color=[0.8, 0.8, 0.8]);

# plot basis functions
for i in range(0 , len(lambdas)):
  plot( xvals, abs(vals_kd[i,:]), '-', color=cols[i]);


execfile("legPostVisualizationTight.py");
ylim( [-30.0, 30.0]);

plt.savefig( 'figures/legPlotRKBasisBad_c.eps')
plt.savefig( 'figures/legPlotRKBasisBad_c.pdf')