# Plot reproducing kernels at three points in [-1,1]

execfile('legInit.py');

# locations of reproducing kernels
lambdas = [-0.8, 0.1, 0.5];

# generate values
vals_rks = zeros( (len( lambdas), len(xvals)));

for n in range (0 , n_leg+1):
  
  # value of basis functions
  cdat = Legendre.eval( n, xvals);
  # basis function coefficients
  coeffs = np.transpose(matrix(Legendre.eval( n, lambdas))).tolist();
  
  # accumulate contribution by current basis function
  vals_rks = vals_rks + coeffs * cdat;
  


# visualize
execfile('legPreVisualization.py');

# plot reproducing kernels
plot( xvals, vals_rks[0,:], '-r');
plot( xvals, vals_rks[1,:], '-g');
plot( xvals, vals_rks[2,:], '-b');

# plot corresponding lambads
plot( lambdas[0], 0.0, 'xr');#, 'MarkerSize', 15);
plot( lambdas[1], 0.0, 'xg');#, 'MarkerSize', 15);
plot( lambdas[2], 0.0, 'xb');#, 'MarkerSize', 15);

execfile('legPostVisualization.py');
ylim( [-2.5, 2.5])
plt.savefig( 'figures/legPlotReproducingKernel.eps')
plt.savefig( 'figures/legPlotReproducingKernel.pdf')


