# Plot basis expansion for Legendre polynomials

execfile('legInit.py')

# random signals (coefficients for n_leg = 4)
# coeffs_2 = 0.5 * randn( 1, n_leg+1);
# fix coefficients for reproducibility
coeffs_1 = [0.7097, 0.1458, 0.0989, 0.7938, -0.4022];
coeffs_2 = [0.2600, -0.0100, -0.0174, -0.3991, 0.5093];
coeffs_sum = np.add(coeffs_1 , coeffs_2);

# generate signal samples
sig_vals_1 = Legendre.signal(coeffs_1, xvals);
sig_vals_2 = Legendre.signal(coeffs_2, xvals);
sig_vals_sum = Legendre.signal(coeffs_sum, xvals);

# visualize
execfile('legPreVisualization.py');

# plot signal
plot( xvals, sig_vals_1, '--g');
plot( xvals, sig_vals_2, '--b');
plot( xvals, sig_vals_sum, '-r');

# set parameters for saving
execfile('legPostVisualization.py');
# save image
plt.savefig( 'figures/legPlotSignalAddition.eps')
plt.savefig( 'figures/legPlotSignalAddition.pdf')

