from legKernelMatrix import *
def legRKApproximate( n_leg, n_leg_approx, lambdas, coeffs, xvals ):
#
# f_approx, coeffs_approx, condK] = ...
#   legRKApproximate( n_leg, n_leg_approx, lambdas, coeffs, xvals )
#
# Approximate Legendre polynomial signal using RK basis.

  f_approx ={}
  K = legKernelMatrix( n_leg_approx, lambdas);
  S = pinv(K);
  f_approx['condK']= cond(K);

  f_samples = Legendre.signal(coeffs, lambdas);
  
  
  f_approx['coeffs'] = np.array(transpose( S * transpose(matrix(f_samples))))[0,:];  

  f_approx['vals'] = Legendre.signal( f_approx['coeffs'], xvals);
  
  return f_approx