import numpy as np
import scipy.special as sp
import matplotlib.pyplot as plt
from pylab import *
from legendre import *
# Construct a random characteristic basis
execfile("legInit.py");
# number of basis functions
n = 10;

# width of basis function
# dw = rand( 1, n);
# dw = (2.0 / sum(dw)) * dw;
# Fix for reproducibility
dw = [ 0.2937, 0.0914, 0.1411, 0.1025, 0.3875,\
       0.2006, 0.3541, 0.2037, 0.1582, 0.0672];

# x coordinates for different partitions
xs = -1.0 + np.append(0.0,cumsum(dw));

## heights of normalized basis functions \bar{\chi}_i
heights_norm = 1.0 / sqrt(dw);

## construct reproducing kernel functions
heights_rk = 1.0 / np.array(dw);

### Visualization

execfile("legPreVisualization.py");

for i in range (0, (len(dw))):
  plot( [ xs[i], xs[i], xs[i+1], xs[i+1]],\
        [ 0.0, heights_norm[i], heights_norm[i], 0.0], color=[0.0,0.0,1.0]); 

  
execfile("legPostVisualizationTight.py");
ylim( [0.0, max( heights_norm)]);

plt.savefig( 'figures/plotCharacteristicBasis.eps')
plt.savefig( 'figures/plotCharacteristicBasis.pdf')


### plot reproducing kernel basis
f=plt.figure();
execfile("legPreVisualization.py");

f.hold(1)
## plot the ortho basis functions shaded in the back
for i in range (0, (len(dw))):
  plot( [ xs[i], xs[i], xs[i+1], xs[i+1]], \
        [0.0, heights_norm[i], heights_norm[i], 0.0], color=[0.8,0.8,1.0]); 
  
## plot reproducing kernel basis functions
for i in range (0, (len(dw))):
  plot( [ xs[i], xs[i], xs[i+1], xs[i+1]], \
        [ 0.0, heights_rk[i], heights_rk[i], 0.0], color=[1.0,0.0,0.0]); 


execfile("legPostVisualizationTight.py");
ylim( [0.0, max( heights_rk)]);

plt.savefig( 'figures/plotCharacteristicBasis_rk.eps')
plt.savefig( 'figures/plotCharacteristicBasis_rk.pdf')
