
from legKernelMatrix import *
from legEnKernelMatrix import *
from scipy import optimize
def legOptProgressCallback( xk):
#
#
#

  # collect data only through iterations
  K = legKernelMatrix( n_leg, xk);
  en = cond(K) - 1.0;
    
  ## save current energy 
  history[0]=history[0]+[en]
  history[1]=history[1]+[xk]

  return

# optimize sampling points and plot development of location, also 
# analyze difference in reconstruction error

execfile("legInit.py");

os_rate = 2.0;

# construct initial sampling points
# lambdas_init = rand( os_rate * (n_leg+1), 1);
# lambdas_init = sort( (2.0 * lambdas_init) - 1.0)';
# Fix points for reproducibility
lambdas_init = [-0.5263,-0.3424,-0.1966,-0.0870,0.0786,0.4660,\
                0.5814,0.6152,0.8815,0.9417];

# initial condition number
cond_init = cond( legKernelMatrix( n_leg, lambdas_init));

# variable to retain optimization history
history= np.array([[],[lambdas_init]]);
history[0]=[cond_init-1];

# generate lower and upper bounds for locations for optimization
lb = -1.0 * ones( size(lambdas_init));
ub = ones( len(lambdas_init));
bound = map(np.append, lb, ub)

# use active set algorithm 
#options = optimset( 'Algorithm', 'active-set', ...
                    #'OutputFcn', @legOptProgressCallback, ...
                    #'Display', 'iter', ...
                    #'TolFun', 1e-12, ...
                    #'TolX', 1e-10, ...
                    #'MaxFunEvals', 10000);

# construct the energy function that only has one parameter
enFunc = legEnKernelMatrix;

# run optimization
lambdas_opt=optimize.minimize(enFunc, 
                              lambdas_init, 
                              args=[n_leg], 
                              method='BFGS',  ##TODO fix
                              ## method chosen so that intermediate 
                              ## results show, but doesnt take bounded constraints
                              bounds=bound, 
                              tol=1e-12, 
                              callback=legOptProgressCallback,
                              options={'eps': 1e-10,'disp':True}).x


cond_opt = cond( legKernelMatrix( n_leg, lambdas_opt));

## Visualization 

execfile("legPreVisualization.py");
plot( arange(0,len(history[0])), np.array(history[0]) + 1.0, '-xr');
execfile("legPostVisualization.py");
xlim( [0, len(history[0])-1]);
ylim( [1, max(history[0])+ 1]);

yscale('log')
yticks([1e0, 1e1, 1e2, 1e3])

plt.savefig( 'figures/legPlotOversamplingOptimized.eps')
plt.savefig( 'figures/legPlotOversamplingOptimized.pdf')


## Visualization of initial and final points
plt.figure()
execfile("legPreVisualization.py");

for i in range (0 , len(lambdas_opt)):  
  plot( lambdas_init[i], 0.0, 'o', color=cols[i], linewidth=1.25);
  plot( lambdas_opt[i], 0.0, 'x', color=cols[i], markersize=15, linewidth=1.25);

execfile("legPostVisualization.py");

plt.savefig( 'figures/legPlotOversamplingOptimized_lambdas.eps')
plt.savefig( 'figures/legPlotOversamplingOptimized_lambdas.pdf')



