import numpy as np
from scipy.interpolate import *
import scipy.special as sp
import matplotlib.pyplot as plt
from pylab import *

#
# [f,df] = signal( x)
# 
# Test function in [-1,1] (with derivative if necessary / desired)
#
# @param x_in  x values in [0,1]
class SignalCharacteristic:
  @staticmethod
  def signal( xvals):
    #
    # fvals = signalCharacteristic( xvals)
    #
    # Test signal in the space spanned by characteristic functions.
    #
    # @param xvals  evaluation points for the signal
  
    # set  up signal
    heights = [ 0.2, 0.3, 0.35, 0.25, 0.1, -0.05, -0.15, -0.2, 
                -0.25, -0.1, 0.0, 0.2, 0.5, 0.7, 0.6, 0.5,
                0.4, 0.35, 0.3, 0.35, 0.375];
    x_lims = linspace(-1.0 , 1.0, 21)
  
    fvals = zeros( len( xvals));
  
    # fill in function values
    for i in range(0 , len(x_lims)):
      n = [j for j in range(0,len(xvals)) if xvals[j] > x_lims[i] \
           and xvals[j] <= x_lims[i+1]];
      for k in n:
        fvals[k] = heights[i];
    return fvals
