import numpy as np
from scipy.interpolate import *
import scipy.special as sp
import matplotlib.pyplot as plt
from pylab import *

#
# [f,df] = signal( x)
# 
# Test function in [-1,1] (with derivative if necessary / desired)
#
# @param x_in  x values in [0,1]
class SignalSingularities:
    @staticmethod
    def signal(x_in):
    
        f = zeros( len( x_in))
        df = zeros( len( x_in))
        
        idx = [i for i in range(0,len(x_in)) if x_in[i]>=-1 and x_in[i]<=-0.3]
        x = [x_in[i] for i in idx]
        xx = linspace(-1.0, -0.3, 8)
        yy = [-0.3, -0.1, 0.4, 0.2, 0.0, -0.6, -0.6, -0.1]
        
        spline =InterpolatedUnivariateSpline(xx,yy)
        for i in idx:
            f[i] = spline(x_in[i])
        
        ## derivative
        df[idx] = spline.derivatives(x)[1]
        
        
        
        idx = [i for i in range(0,len(x_in)) if x_in[i]>=-0.3 and x_in[i]<=0.17]
        x = [x_in[i] for i in idx]
        xx = np.append(arange(-0.3, 0.17, 0.1),0.17)
        yy = [0.5, 0.2, 0.3, 0.2, 0.4, 1.5]
        spline =InterpolatedUnivariateSpline(xx,yy)
        for i in idx:
            f[i] = spline(x_in[i])
        
        ## derivative
        if (len(x)!=0):
            df[idx] = spline.derivatives(x)[1]
        
       
        
        
        idx = [i for i in range(0,len(x_in)) if x_in[i]>=0.17 and x_in[i]<=0.8]
        x = [x_in[i] for i in idx]
        xx = np.append(0.17,arange(0.2, 0.8, 0.1))
        yy = [1.5, -0.1, -0.3, -0.3, -0.12, 0.05, 0.1, 0.1]
        spline =InterpolatedUnivariateSpline(xx,yy)
        for i in idx:
            f[i] = spline(x_in[i])
        ## derivative
        if (len(x)!=0):
            df[idx] = spline.derivatives(x)[1]


        
        idx = [i for i in range(0,len(x_in)) if x_in[i]>=0.8 and x_in[i]<=1.]
        x = [x_in[i] for i in idx]
        xx = linspace(0.8, 1.0, 5)
        yy = [0.3, 0.275, 0.2, 0.075,-0.1]
        spline =InterpolatedUnivariateSpline(xx,yy)
        for i in idx:
            f[i] = spline(x_in[i])
        
        ## derivative
        if (len(x)!=0):
            df[idx] = spline.derivatives(x)[1]
        
        return f
